/*
 * Copyright 2010-2014 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the cloudfront-2015-04-17.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.CloudFront.Model
{
    /// <summary>
    /// Container for the parameters to the GetStreamingDistributionConfig operation.
    /// Get the configuration information about a streaming distribution.
    /// </summary>
    public partial class GetStreamingDistributionConfigRequest : AmazonCloudFrontRequest
    {
        private string _id;

        /// <summary>
        /// Empty constructor used to set  properties independently even when a simple constructor is available
        /// </summary>
        public GetStreamingDistributionConfigRequest() { }

        /// <summary>
        /// Instantiates GetStreamingDistributionConfigRequest with the parameterized properties
        /// </summary>
        /// <param name="id">The streaming distribution's id.</param>
        public GetStreamingDistributionConfigRequest(string id)
        {
            _id = id;
        }

        /// <summary>
        /// Gets and sets the property Id. The streaming distribution's id.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }

        // Check to see if Id property is set
        internal bool IsSetId()
        {
            return this._id != null;
        }

    }
}